import { world, system } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";

const ui = new ActionFormData()
    .title("Backpack Register")
    .body("Just Click On Register")
    .button("Register");

world.afterEvents.itemUse.subscribe(async (event) => {
    const { source, itemStack } = event;

    if (itemStack.typeId === "zc:bpris") {
        try {
            const response = await ui.show(source);
            if (!response.canceled && response.selection === 0) { 
                const { x, y, z } = source.location;
                const playerName = source.name; 


                await source.dimension.runCommandAsync(`summon zc:bpet1 ${x} ${y} ${z}`);
                await source.dimension.runCommandAsync(`summon zc:bpet2 ${x} ${y} ${z}`);
                await source.dimension.runCommandAsync(`summon zc:bpet3 ${x} ${y} ${z}`);
                await source.dimension.runCommandAsync(`summon zc:bpet4 ${x} ${y} ${z}`);

                await source.dimension.runCommandAsync(`tag @e[type=zc:bpet1,x=${x},y=${y},z=${z},r=1] add ${playerName}`);
                await source.dimension.runCommandAsync(`tag @e[type=zc:bpet2,x=${x},y=${y},z=${z},r=1] add ${playerName}`);
                await source.dimension.runCommandAsync(`tag @e[type=zc:bpet3,x=${x},y=${y},z=${z},r=1] add ${playerName}`);
                await source.dimension.runCommandAsync(`tag @e[type=zc:bpet4,x=${x},y=${y},z=${z},r=1] add ${playerName}`);

                await source.runCommandAsync(`clear @s zc:bpris 0 1`);
            }
        } catch (error) {
            console.error("Error displaying UI or running commands:", error);
        }
    }
});




function mainTick() {
    for (const player of world.getPlayers()) {
        const playerName = player.name; 
        
        
        world.getDimension("overworld").runCommandAsync(
            `tp @e[type=zc:bpet1,tag=${playerName},c=1] @p[hasitem={item=zc:wbp1,location=slot.weapon.mainhand},name=${playerName},c=1]`
        ).catch(error => console.warn(`Command failed: ${error}`));      
        
          world.getDimension("overworld").runCommandAsync(
            `tp @e[type=zc:bpet1,tag=${playerName},c=1] 10000 -104 10000`
        ).catch(error => console.warn(`Command failed: ${error}`));
             
        world.getDimension("overworld").runCommandAsync(
            `tp @e[type=zc:bpet1,tag=${playerName},c=1] @p[hasitem={item=zc:wbp1,location=slot.weapon.mainhand},name=${playerName},c=1]`
        ).catch(error => console.warn(`Command failed: ${error}`));
        
        
        
        
        
        
        
    
    world.getDimension("overworld").runCommandAsync(
            `tp @e[type=zc:bpet2,tag=${playerName},c=1] @p[hasitem={item=zc:wbp2,location=slot.weapon.mainhand},name=${playerName},c=1]`
        ).catch(error => console.warn(`Command failed: ${error}`));
           
        world.getDimension("overworld").runCommandAsync(
            `tp @e[type=zc:bpet2,tag=${playerName},c=1] 10000 -104 10000`
        ).catch(error => console.warn(`Command failed: ${error}`));
              
        world.getDimension("overworld").runCommandAsync(
            `tp @e[type=zc:bpet2,tag=${playerName},c=1] @p[hasitem={item=zc:wbp2,location=slot.weapon.mainhand},name=${playerName},c=1]`
        ).catch(error => console.warn(`Command failed: ${error}`));
        
        
        
        
        
    
    
    world.getDimension("overworld").runCommandAsync(
            `tp @e[type=zc:bpet3,tag=${playerName},c=1] @p[hasitem={item=zc:wbp3,location=slot.weapon.mainhand},name=${playerName},c=1]`
        ).catch(error => console.warn(`Command failed: ${error}`));
        
    world.getDimension("overworld").runCommandAsync(
            `tp @e[type=zc:bpet3,tag=${playerName},c=1] 10000 -104 10000`
        ).catch(error => console.warn(`Command failed: ${error}`));
          
    world.getDimension("overworld").runCommandAsync(
            `tp @e[type=zc:bpet3,tag=${playerName},c=1] @p[hasitem={item=zc:wbp3,location=slot.weapon.mainhand},name=${playerName},c=1]`
        ).catch(error => console.warn(`Command failed: ${error}`));
    
    
    
    
    
    
    
    
    
    world.getDimension("overworld").runCommandAsync(
            `tp @e[type=zc:bpet4,tag=${playerName},c=1] @p[hasitem={item=zc:wbp4,location=slot.weapon.mainhand},name=${playerName},c=1]`
        ).catch(error => console.warn(`Command failed: ${error}`));
        
        world.getDimension("overworld").runCommandAsync(
            `tp @e[type=zc:bpet4,tag=${playerName},c=1] 10000 -104 10000`
        ).catch(error => console.warn(`Command failed: ${error}`));
        
        world.getDimension("overworld").runCommandAsync(
            `tp @e[type=zc:bpet4,tag=${playerName},c=1] @p[hasitem={item=zc:wbp4,location=slot.weapon.mainhand},name=${playerName},c=1]`
        ).catch(error => console.warn(`Command failed: ${error}`));
        
        world.getDimension("overworld").runCommandAsync(
            `execute @a[tag=!lc] ~~~ tickingarea add 10000 -104 10000 10000 -103 10000 lc`
        ).catch(error => console.warn(`Command failed: ${error}`));
        world.getDimension("overworld").runCommandAsync(
            `give @a[tag=!lc] zc:bpris 1 0`
        ).catch(error => console.warn(`Command failed: ${error}`));
        world.getDimension("overworld").runCommandAsync(
            `tag @a[tag=!lc] add lc`
        ).catch(error => console.warn(`Command failed: ${error}`));
    }
    
    
    
    
    system.run(mainTick); 
}


system.run(mainTick);
