import { world } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";

function showGraveUI(player) {
    const ui = new ActionFormData()
        .title("§l§4Grave Actions")
        .body("§l§6Select an action:")
        .button("§l§5Teleport", "textures/items/ender_pearl")
        .button("§l§5Clear", "textures/ui/trash");

    ui.show(player).then((response) => {
        if (response.canceled) return;

        if (response.selection === 0) {
            // Teleport player to their tagged grave
            try {
                player.runCommandAsync(
                    `tp @s @e[type=zc:grave,tag=${player.nameTag},c=1]`
                );
                player.sendMessage("§aTeleported to your grave!");
            } catch (error) {
                player.sendMessage("§cNo grave found to teleport to!");
                console.error(`Teleport error: ${error}`);
            }
        } else if (response.selection === 1) {
            // Clear the grave item from the player's inventory
            try {
                player.runCommandAsync(`clear @s zc:grave_res 0 1`);
                player.sendMessage("§aCleared 1 Grave Res from your inventory.");
            } catch (error) {
                player.sendMessage("§cFailed to clear Grave Res!");
                console.error(`Clear error: ${error}`);
            }
        }
    });
}

// Listen for when a player uses the grave item
world.afterEvents.itemUse.subscribe((event) => {
    const { source, itemStack } = event;

    if (itemStack.typeId === "zc:grave_res") {
        showGraveUI(source);
    }
});
