import { ActionFormData } from '@minecraft/server-ui';
import { world } from '@minecraft/server';

function showGraveUI(player) {
  const ui = new ActionFormData()
    .title("§l§4Grave Actions")
    .body("§l§6Select an action:")
    .button("§l§5Open Grave", "textures/items/bone")
    .button("§l§5Clear Key", "textures/ui/trash"); 

  ui.show(player).then((response) => {
    if (response.canceled) return; 

    switch (response.selection) {
      case 0: 
        try {
          
          player.runCommandAsync(
            `tag @s add wn`
          );
          player.runCommandAsync(
            `execute @e[tag="${player.nameTag}",c=1,r=7] ~~~ function gopen`
          );
          player.runCommandAsync(
            `tag @s remove wn`
          );
          
          
        } catch (error) {
          player.sendMessage("§cAn error occurred while processing your request.");
          console.error(`Grave command error: ${error}`);
        }
        break;

      case 1: 
        try {
          player.runCommandAsync(`clear @s zc:grave_key 0 1`);
          player.sendMessage("§a1 Grave Key cleared from your inventory.");
        } catch (error) {
          player.sendMessage("§cFailed to clear Grave Key!");
          console.error(`Clear Key command error: ${error}`);
        }
        break;

      default:
        break;
    }
  });
}

world.afterEvents.itemUse.subscribe((event) => {
  const { source, itemStack } = event;

  if (source && itemStack.typeId === "zc:grave_key") {
    showGraveUI(source);
  }
});

